Reach is a JavaScript framework relying on [Flexible DataSync](https://datasync.orange.com) to quickly add communication features to your website.

Reach acts as a signaling framework for all your WebRTC needs.

[![Build Status](https://travis-ci.org/webcom-components/reach.svg?branch=master)](https://travis-ci.org/webcom-components/reach)
[![Code Climate](https://codeclimate.com/github/webcom-components/reach/badges/gpa.svg)](https://codeclimate.com/github/webcom-components/reach)
[![Test Coverage](https://codeclimate.com/github/webcom-components/reach/badges/coverage.svg)](https://codeclimate.com/github/webcom-components/reach/coverage)
[![ESDoc](./badge.svg)](https://doc.esdoc.org/github.com/webcom-components/reach)
[![npm version](https://img.shields.io/npm/v/webcom-reach.svg)](https://www.npmjs.com/package/webcom-reach)
[![bower version](https://img.shields.io/bower/v/webcom-reach.svg)](https://github.com/webcom-components/reach)
[![Dependency Status](https://david-dm.org/webcom-components/reach.svg)](https://david-dm.org/webcom-components/reach)
[![devDependency Status](https://david-dm.org/webcom-components/reach/dev-status.svg)](https://david-dm.org/webcom-components/reach#info=devDependencies)
[![semantic-release](https://img.shields.io/badge/%F0%9F%93%A6%F0%9F%9A%80-semantic--release-e10079.svg)](https://github.com/semantic-release/semantic-release)
[![Commitizen friendly](https://img.shields.io/badge/commitizen-friendly-brightgreen.svg)](http://commitizen.github.io/cz-cli/)
[![Stories in Ready](https://img.shields.io/waffle/label/webcom-components/reach/ready.svg)](http://waffle.io/webcom-components/reach)
[![Stories in Progress](https://img.shields.io/waffle/label/webcom-components/reach/in%20progress.svg)](http://waffle.io/webcom-components/reach)

[![Sauce Test Status](https://saucelabs.com/browser-matrix/webcomOps.svg)](https://saucelabs.com/u/webcomOps)


## Discover Flexible DataSync

Reach rely heavily on [Flexible DataSync][Quickstart] to exchange data between peers. Take a look at the [Flexible DataSync][Quickstart] documentation and learn how you can exchange data in real-time with a few lines of code.

## Get started

[Get started][ReachSDKDoc] in minutes &amp; add audio and/or video capabilities to your web app.

## Live example

[See how it works][VisioSampleRepo] with an example of a visio web app available [here][VisioSampleApp]. You can check the code for this sample in the dedicated Github [repo][VisioSampleRepo]

[Quickstart]: https://datasync.orange.com/doc/tutorial-quickstart.html
[ReachSDKDoc]: ./manual/tutorial/#getting-started
[VisioSampleRepo]: https://github.com/webcom-components/visio-sample
[VisioSampleApp]: https://webcom-components.github.io/visio-sample
